;; This code handles level selection, player colour, &c.

Sel_Level:
	bcall(_grbufclr)
	ld hl,LargeBuffer+(44*12)
	xor a
	ld bc,768-(44*12)
	bcall(_memset)
	set textwrite,(iy+sgrflags)	;Write to BUFFER

;...Scan for levels!

	ld hl,(ProgPtr)
	ld ix,FileName
	call ionDetect
	jp nz,NoLevels

LoopedFiles:
	ld hl,(ProgPtr)
	ld (ProgPt),hl
FindNextFile:
	
	ld hl,(ProgPt)
	ld ix,FileName
	call ionDetect
	ld (ProgPt),de
	jp nz,LoopedFiles
	inc hl

	ld (HL_Temp),hl
	
	ld hl,LargeBuffer
	ld de,PlotsScreen
	ld bc,768
	ldir

	ld hl,BenRyves

	ld de,(256*28)+25		;'B.R. & J.J. 2003'
	ld (pencol),de
	bcall(_vputs)

	ld de,(256*36)+15		;'Spitfire Prods'
	ld (pencol),de
	bcall(_vputs)

	ld de,(256*46)+22		;'2nd to Play'
	ld (pencol),de
	bcall(_vputs)

	ld de,(256*53)+15		;'Alpha:'
	ld (pencol),de
	bcall(_vputs)

	ld hl,(HL_Temp)
	bcall(_vputs)		;Display level name

	inc hl
	ld de,Map
	ld bc,32*32
	ldir

	call ionfastCopy

LoadingLevelKeyLoop:
	bcall(_getcsc)
	cp sk2nd
	jp z,LoadLevel
	cp skAlpha
	jp z,FindNextFile
	cp skClear
	jp z,QuitGame
	jp LoadingLevelKeyLoop



LoadLevel:

	;/////////////////////////////////////////////////////

	res textwrite,(iy+sgrflags)	;Write to BUFFER off

CHoosePlayer:

	;// Choose player:

	ld hl,PlotsScreen+(44*12)
	ld bc,768-(44*12)
	xor a
	bcall(_memset)

	ld hl,PlotsScreen
	ld de,LargeBuffer
	ld bc,768
	ldir

	call SetSoldierPos_title
	ld ix,GreenRight+32
	call Put_Masked_16_Sprite
	call SetSoldierPos_title
	ld ix,GreenRight
	call PutTile

	call SetSoldierPos_title
	ld ix,TanLeft+32
	ld a,57
	call Put_Masked_16_Sprite
	call SetSoldierPos_title
	ld ix,TanLeft
	ld a,57
	call PutTile


	ld hl,LargeBuffer
	ld de,PlotsScreen
	ld bc,768
	ldir
	


	ld a,(Soldier_Name)

	sla a
	sla a
	sla a
	sla a
	sla a
	add a,25
	ld l,46
	ld ix,Cursor
	ld b,16
	ld c,2
	call ionLargeSprite

	call ionFastCopy
Choose_Colour_Key_Loop:
	bcall(_getcsc)
	cp skClear
	jp z,Sel_Level
	cp skLeft
	jr z,Toggle_Choice
	cp skRight
	jr z,Toggle_Choice
	cp sk2nd
	jr z,Fix_Choice
	jr Choose_Colour_Key_Loop

Toggle_Choice:
	ld a,(Soldier_Name)
	xor 1
	ld (Soldier_Name),a
	jp CHoosePlayer


Fix_Choice:

	ld a,(Soldier_Name)
	or a
	jr nz,Set_Tan
	ld hl,0
	jr Fix_Soldier_Colour

Set_Tan:
	ld hl,Soldier_Sprites_End-Soldier_Sprites_Start

Fix_Soldier_Colour:
	ld (SpriteOffset),hl



	call Set_Right


	;Find spawn point:

	ld a,(Soldier_Name)
	add a,80
	ld e,a


	ld hl,0
	ld (Level.X),hl

	ld hl,Map
FindSLoop:
	ld a,(hl)		

	cp e
	jr z,FoundSpawn

	ld a,(Level.X)
	inc a
	ld (Level.X),a
	
	cp 32
	jr nz,NotLoopedX


	xor a
	ld (Level.X),a
	ld a,(Level.Y)
	inc a
	ld (Level.Y),a

NotLoopedX:
	inc hl
	jr FindSLoop

FoundSpawn:

	;Fill in the spawwnpoint with blank soil:
	call GetAddOfTile
	xor a
	ld (hl),a

	;...And amend the pos:
	ld a,(Level.X)
	sub 2
	ld (Level.X),a
	ld a,(Level.Y)
	dec a
	ld (Level.Y),a

	;....	

	xor a
	ld (Weapon_Num),a

	ld hl,0
	ld (Scrolled.X),hl

	;'Connecting':

	ld hl,PlotsScreen+(44*12)
	ld bc,768-(44*12)
	xor a
	bcall(_memset)
	
	call ionFastCopy

	ld hl,Connect_1
	ld a,1
	ld (curcol),a
	ld a,6
	ld (currow),a
	bcall(_puts)

	jp Loaded


NoLevels:
	ld hl,NoLevels
	bcall(_homeup)
	ld a,5
	ld (currow),a
	ld hl,NoLevels_txt
	bcall(_puts)
	
Key_No_Lev:
	bcall(_getcsc)
	or a
	jr z,Key_No_Lev


	jp QuitGame

NoLevels_txt:
	;;;;;0123456789ABCDEF
	.db "No levels found!",0


Loaded:

